package org.openqa.selenium.devtools.v90.network.model;

import org.openqa.selenium.Beta;
import org.openqa.selenium.json.JsonInput;

@org.openqa.selenium.Beta()
public class SecurityIsolationStatus {

    private final java.util.Optional<org.openqa.selenium.devtools.v90.network.model.CrossOriginOpenerPolicyStatus> coop;

    private final java.util.Optional<org.openqa.selenium.devtools.v90.network.model.CrossOriginEmbedderPolicyStatus> coep;

    public SecurityIsolationStatus(java.util.Optional<org.openqa.selenium.devtools.v90.network.model.CrossOriginOpenerPolicyStatus> coop, java.util.Optional<org.openqa.selenium.devtools.v90.network.model.CrossOriginEmbedderPolicyStatus> coep) {
        this.coop = coop;
        this.coep = coep;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v90.network.model.CrossOriginOpenerPolicyStatus> getCoop() {
        return coop;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v90.network.model.CrossOriginEmbedderPolicyStatus> getCoep() {
        return coep;
    }

    private static SecurityIsolationStatus fromJson(JsonInput input) {
        java.util.Optional<org.openqa.selenium.devtools.v90.network.model.CrossOriginOpenerPolicyStatus> coop = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v90.network.model.CrossOriginEmbedderPolicyStatus> coep = java.util.Optional.empty();
        input.beginObject();
        while (input.hasNext()) {
            switch(input.nextName()) {
                case "coop":
                    coop = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v90.network.model.CrossOriginOpenerPolicyStatus.class));
                    break;
                case "coep":
                    coep = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v90.network.model.CrossOriginEmbedderPolicyStatus.class));
                    break;
                default:
                    input.skipValue();
                    break;
            }
        }
        input.endObject();
        return new SecurityIsolationStatus(coop, coep);
    }
}
